--===================================================================
--
-- (C) Copyright IBM Corp. 2005, 2006  All Rights Reserved.                        
--                                                                           
--  Licensed Materials - Property of IBM                                                 
--                                                          
-- US Government Users Restricted Rights - Use, duplication or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.  
--              
-- You may copy, modify, and distribute this sample program in any           
-- form without payment to IBM,  for any purpose including developing,       
-- using, marketing or distributing programs that include or are             
-- derivative works of the sample program.                                   
--                                                                           
-- The sample program is provided to you on an "AS IS" basis, without        
-- warranty of any kind.  IBM HEREBY  EXPRESSLY DISCLAIMS ALL WARRANTIES,    
-- EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED     
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.       
-- Some jurisdictions do not allow for the exclusion or limitation of        
-- implied warranties, so the above limitations or exclusions may not        
-- apply to you.  IBM shall not be liable for any damages you suffer as      
-- a result of using, modifying or distributing the sample program or        
-- its derivatives.                                                          
--===================================================================

-- CREATE TRIGGERS FOR CLAIM TABLE
DROP TRIGGER CLAIMCREATE;
CREATE TRIGGER CLAIMCREATE AFTER INSERT ON CLAIM REFERENCING NEW AS NEWROW FOR EACH ROW MODE DB2SQL BEGIN ATOMIC INSERT INTO EVENTTABLE(TYPE, TRIGGER, KEYTYPE, KEYVALUE, CREATETIMESTAMP) VALUES('CLAIM', 'C', 'INT', RTRIM(CHAR(NEWROW.ID)), CURRENT TIMESTAMP); END;

DROP TRIGGER CLAIMUPDATE;
CREATE TRIGGER CLAIMUPDATE AFTER UPDATE ON CLAIM REFERENCING OLD AS OLDROW FOR EACH ROW MODE DB2SQL BEGIN ATOMIC INSERT INTO EVENTTABLE(TYPE, TRIGGER, KEYTYPE, KEYVALUE, CREATETIMESTAMP) VALUES('CLAIM', 'U', 'INT', RTRIM(CHAR(OLDROW.ID)), CURRENT TIMESTAMP); END;

DROP TRIGGER CLAIMDELETE;
CREATE TRIGGER CLAIMDELETE AFTER DELETE ON CLAIM REFERENCING OLD AS OLDROW FOR EACH ROW MODE DB2SQL BEGIN ATOMIC INSERT INTO EVENTTABLE(TYPE, TRIGGER, KEYTYPE, KEYVALUE, CREATETIMESTAMP) VALUES('CLAIM', 'D', 'INT', RTRIM(CHAR(OLDROW.ID)), CURRENT TIMESTAMP); END;
