--===================================================================
--
-- (C) Copyright IBM Corp. 2005, 2006  All Rights Reserved.                        
--                                                                           
--  Licensed Materials - Property of IBM                                                 
--                                                          
-- US Government Users Restricted Rights - Use, duplication or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.  
--              
-- You may copy, modify, and distribute this sample program in any           
-- form without payment to IBM,  for any purpose including developing,       
-- using, marketing or distributing programs that include or are             
-- derivative works of the sample program.                                   
--                                                                           
-- The sample program is provided to you on an "AS IS" basis, without        
-- warranty of any kind.  IBM HEREBY  EXPRESSLY DISCLAIMS ALL WARRANTIES,    
-- EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED     
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.       
-- Some jurisdictions do not allow for the exclusion or limitation of        
-- implied warranties, so the above limitations or exclusions may not        
-- apply to you.  IBM shall not be liable for any damages you suffer as      
-- a result of using, modifying or distributing the sample program or        
-- its derivatives.                                                          
--===================================================================

-- CREATE EVENT TABLE
DROP TABLE EVENTTABLE;
CREATE TABLE EVENTTABLE(
	SID				BIGINT PRIMARY KEY GENERATED ALWAYS AS IDENTITY (START WITH 1 INCREMENT BY 1),
	TYPE			VARCHAR(256) NOT NULL,
	TRIGGER			CHAR(1) NOT NULL,
	KEYTYPE			VARCHAR(256) NOT NULL,
	KEYVALUE		VARCHAR(256) NOT NULL,
	CREATETIMESTAMP	TIMESTAMP NOT NULL
);

-- CREATE LOG TABLE
DROP TABLE LOGTABLE;
CREATE TABLE LOGTABLE(
	SID				BIGINT PRIMARY KEY NOT NULL,
	TYPE			VARCHAR(256) NOT NULL,
	TRIGGER			CHAR(1) NOT NULL,
	KEYTYPE			VARCHAR(256) NOT NULL,
	KEYVALUE		VARCHAR(256) NOT NULL,
	CREATETIMESTAMP	TIMESTAMP NOT NULL,
	RESULT			CHAR(1) NOT NULL,
	LOGTIMESTAMP	TIMESTAMP NOT NULL
);

-- CREATE PROCEDURES
DROP PROCEDURE LOGPROC;
CREATE PROCEDURE LOGPROC (IN ESID BIGINT, IN ERESULT CHAR(1)) LANGUAGE SQL MODIFIES SQL DATA P1: BEGIN DECLARE ETYPE VARCHAR(256); DECLARE ETRIGGER CHAR(1); DECLARE EKEYTYPE VARCHAR(256); DECLARE EKEYVALUE VARCHAR(256); DECLARE ECREATETIMESTAMP TIMESTAMP; DECLARE C1 CURSOR WITH RETURN FOR SELECT TYPE, TRIGGER, KEYTYPE, KEYVALUE, CREATETIMESTAMP FROM EVENTTABLE WHERE SID=ESID; OPEN C1; FETCH C1 INTO ETYPE, ETRIGGER, EKEYTYPE, EKEYVALUE, ECREATETIMESTAMP; CLOSE C1; INSERT INTO LOGTABLE VALUES(ESID, ETYPE, ETRIGGER, EKEYTYPE, EKEYVALUE, ECREATETIMESTAMP, ERESULT, CURRENT TIMESTAMP); DELETE FROM EVENTTABLE WHERE SID=ESID; END P1;

