--===================================================================
--
-- (C) Copyright IBM Corp. 2005, 2006  All Rights Reserved.
--
--  Licensed Materials - Property of IBM
--
-- US Government Users Restricted Rights - Use, duplication or disclosure
-- restricted by GSA ADP Schedule Contract with IBM Corp.
--
-- You may copy, modify, and distribute this sample program in any
-- form without payment to IBM,  for any purpose including developing,
-- using, marketing or distributing programs that include or are
-- derivative works of the sample program.
--
-- The sample program is provided to you on an "AS IS" basis, without
-- warranty of any kind.  IBM HEREBY  EXPRESSLY DISCLAIMS ALL WARRANTIES,
-- EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
-- WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
-- Some jurisdictions do not allow for the exclusion or limitation of
-- implied warranties, so the above limitations or exclusions may not
-- apply to you.  IBM shall not be liable for any damages you suffer as
-- a result of using, modifying or distributing the sample program or
-- its derivatives.
--===================================================================

-- CREATE TRIGGERS FOR ORDER TABLE
DROP TRIGGER ORDERCREATE;
CREATE TRIGGER ORDERCREATE AFTER INSERT ON ORDER REFERENCING NEW AS NEWROW FOR EACH ROW MODE DB2SQL BEGIN ATOMIC INSERT INTO EVENTTABLE(TYPE, TRIGGER, KEYTYPE, KEYVALUE, CREATETIMESTAMP) VALUES('ORDER', 'C', 'INT', RTRIM(CHAR(NEWROW.ORDERID)), CURRENT TIMESTAMP); END;

DROP TRIGGER ORDERUPDATE;
CREATE TRIGGER ORDERUPDATE AFTER UPDATE ON ORDER REFERENCING OLD AS OLDROW FOR EACH ROW MODE DB2SQL BEGIN ATOMIC INSERT INTO EVENTTABLE(TYPE, TRIGGER, KEYTYPE, KEYVALUE, CREATETIMESTAMP) VALUES('ORDER', 'U', 'INT', RTRIM(CHAR(OLDROW.ORDERID)), CURRENT TIMESTAMP); END;

DROP TRIGGER ORDERDELETE;
CREATE TRIGGER ORDERDELETE AFTER DELETE ON ORDER REFERENCING OLD AS OLDROW FOR EACH ROW MODE DB2SQL BEGIN ATOMIC INSERT INTO EVENTTABLE(TYPE, TRIGGER, KEYTYPE, KEYVALUE, CREATETIMESTAMP) VALUES('ORDER', 'D', 'INT', RTRIM(CHAR(OLDROW.ORDERID)), CURRENT TIMESTAMP); END;
