// ===================================================================
// (C) Copyright IBM Corp. 2005, 2006 All Rights Reserved.
//                                                                           
// Licensed Materials - Property of IBM
//                                                          
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//              
// You may copy, modify, and distribute this sample program in any
// form without payment to IBM, for any purpose including developing,
// using, marketing or distributing programs that include or are
// derivative works of the sample program.
//                                                                           
// The sample program is provided to you on an "AS IS" basis, without
// warranty of any kind. IBM HEREBY EXPRESSLY DISCLAIMS ALL WARRANTIES,
// EITHER EXPRESS OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
// Some jurisdictions do not allow for the exclusion or limitation of
// implied warranties, so the above limitations or exclusions may not
// apply to you. IBM shall not be liable for any damages you suffer as
// a result of using, modifying or distributing the sample program or
// its derivatives.
//===================================================================
package com.ibm.wbimonitor.samples.emitterframework;

import org.eclipse.hyades.logging.events.cbe.CommonBaseEvent;

import com.ibm.wbimonitor.samples.emitterframework.exception.EventFormatFailedException;

/*
 * The EventFormatter interface. Implementers of the format interface conver the
 * "native" event Object o into a well-formed CBE for emission to the CEI.
 */
public interface EventFormatter {

    /*
     * Format the serialized Object o to a CommonBaseEvent ojbect.
     */
    public CommonBaseEvent format( Object o ) throws EventFormatFailedException;
}